"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports["default"] = void 0;
var _form = _interopRequireDefault(require("antd/lib/form"));
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));
var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));
var _react = _interopRequireWildcard(require("react"));
var _hoc = require("../../utils/hoc");
var _excluded = ["values"],
  _excluded2 = ["children"];
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
var Form = /*#__PURE__*/function (_Component) {
  (0, _inheritsLoose2["default"])(Form, _Component);
  function Form() {
    var _this;
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _Component.call.apply(_Component, [this].concat(args)) || this;
    _this.formRef = /*#__PURE__*/(0, _react.createRef)();
    return _this;
  }
  var _proto = Form.prototype;
  _proto.componentDidUpdate = function componentDidUpdate(prevProps) {
    var prevValues = prevProps.values;
    var currentValues = this.props.values;
    if (prevValues !== currentValues) {
      if (currentValues && Object.keys(currentValues).length > 0) {
        this.formRef.current.setFieldsValue(currentValues);
      } else {
        this.formRef.current.resetFields();
      }
    }
  };
  _proto.componentDidMount = function componentDidMount() {
    var _this2 = this;
    var values = this.props.values;
    Object.defineProperties(this, Object.keys(this.formRef.current).reduce(function (out, key) {
      var property = _this2.formRef.current[key];
      var getter = function getter() {
        return property;
      };
      if (typeof property === 'function') {
        getter = function getter() {
          return property.bind(_this2.formRef.current);
        };
      }
      out[key] = {
        get: getter
      };
      return out;
    }, {}));

    // 绑定表达式的时候，初次不生效，需要第一次调用一下 setFieldsValue
    if (values) {
      this.formRef.current.setFieldsValue(values);
    }
  };
  _proto.render = function render() {
    var _this$props = this.props,
      values = _this$props.values,
      rest = (0, _objectWithoutPropertiesLoose2["default"])(_this$props, _excluded);
    return /*#__PURE__*/_react["default"].createElement(_form["default"], (0, _extends2["default"])({
      ref: this.formRef
    }, rest));
  };
  return Form;
}(_react.Component);
Form.Item = function (props) {
  var name = props.name,
    requiredobj = props.requiredobj,
    typeobj = props.typeobj,
    patternobj = props.patternobj,
    lenobj = props.lenobj,
    _validator = props.validator;
  var rules = [];
  if (requiredobj && requiredobj.required) {
    rules.push(requiredobj);
  }
  if (typeobj && typeobj.type) {
    rules.push(typeobj);
  }
  if (patternobj && patternobj.pattern) {
    rules.push(patternobj);
  }
  if (lenobj && (lenobj.max || lenobj.min)) {
    rules.push(lenobj);
  }
  if (_validator && typeof _validator === 'function') {
    rules.push({
      validator: function validator(_, value) {
        return _validator(value);
      }
    });
  }
  var namePath = typeof name === 'string' && name.indexOf('.') > 0 ? name.split('.') : name;

  // https://ant.design/components/form-cn/#components-form-demo-complex-form-control
  // <Form.Item name="field" /> 只会对它的直接子元素绑定表单功能
  var children = props.children,
    other = (0, _objectWithoutPropertiesLoose2["default"])(props, _excluded2);
  var node = children;
  if (Array.isArray(children) && children.length === 1) {
    // 如果 children.length > 1， 说明 Form.Item 只充当布局的作用
    node = children[0];
  }
  return /*#__PURE__*/_react["default"].createElement(_form["default"].Item, (0, _extends2["default"])({}, other, {
    name: namePath,
    rules: rules
  }), node);
};
Form.List = (0, _hoc.withSingleFunctionChild)(_form["default"].List);
var _default = Form;
exports["default"] = _default;