import snippets from './snippets';

export default {
  snippets,
  componentName: 'Box',
  title: '布局容器',
  category: '布局',
  props: [
    {
      name: 'className',
      title: { label: '样式类', tip: '样式类' },
      propType: 'string',
    },
    {
      name: 'width',
      title: { label: '宽度', tip: '宽度' },
      propType: 'number',
    },
    {
      name: 'height',
      title: { label: '高度', tip: '高度' },
      propType: 'number',
    },
    {
      name: 'overflowY',
      title: {
        label: '纵向处理',
        tip: '纵向处理',
      },
      setter: {
        componentName: 'SelectSetter',
        props: {
          options: [
            {
              title: '自动',
              value: 'auto',
            },
            {
              title: '滚动',
              value: 'scroll',
            },
            {
              title: '隐藏',
              value: 'hidden',
            },
          ],
        },
      },
      propType: {
        type: 'oneOf',
        value: ['auto', 'scroll', 'hidden'],
      },
    },
    {
      name: 'overflowX',
      title: {
        label: '横向处理',
        tip: '横向处理',
      },
      setter: {
        componentName: 'SelectSetter',
        props: {
          options: [
            {
              title: '自动',
              value: 'auto',
            },
            {
              title: '滚动',
              value: 'scroll',
            },
            {
              title: '隐藏',
              value: 'hidden',
            },
          ],
        },
      },
      propType: {
        type: 'oneOf',
        value: ['auto', 'scroll', 'hidden'],
      },
    },
  ],
  configure: {
    supports: { style: true },
    component: { isContainer: true, className: true }
  },
};
